function piece(positionx, positiony, taille, couleur, qualite, horloge, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.taille = taille;
    this.couleur = couleur;
    //0=bleu
    //1=rouge
    //2=jaune
    //3=violet
    //4=vert
    //5=orange
    this.qualite = qualite;
    //qualite 0 = bien
    //qualite 1 = defectueux
    this.horloge = horloge;
    this.etat = etat;
    //etat 0 = normal
    //autre etat = correspond au bloc dans lequel il se trouve
}

function route(positionx, positiony, longueur, temps, orientation) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.longueur = longueur;
    this.temps = temps;
    //mettre le temps en seconde
    this.orientation = orientation;
    //orientation 1 = horizontal
    //orientation 2 = vertical
}

function spawn(positionx, positiony, couleur, taille) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.couleur = couleur;
    this.taille = taille;
}

function testeur(positionx, positiony, tempsexec, nbpiece, nbmaxpiece, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.tempsexec = tempsexec;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.etat = etat;
}

function separateurproba(positionx, positiony, tempsexec, nbpiece, nbmaxpiece, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.tempsexec = tempsexec;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.etat = etat;
}

function separateursequence(positionx, positiony, tempsexec, nbpiece, nbmaxpiece, sequence, etapesequence, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.tempsexec = tempsexec;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.sequence = sequence;
    //tableau d'une séquence de 0 et de 1
    this.etapesequence = etapesequence;
    this.etat = etat;
}


function feu(positionx, positiony, horloge, tempsrouge, tempsvert, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.horloge = horloge;
    this.tempsrouge = tempsrouge; //temps en seconde passé en rouge
    this.tempsvert = tempsvert; //temps en seconde passé en vert
    this.etat = etat; //0 = rouge et 1 = vert
    //a changer pour changer l'etat initial
}

function empaqueteur(positionx, positiony, nbpiece, nbmaxpiece, couleur, taille, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.couleur = couleur;
    this.taille = taille;
    this.etat = etat;
}

function decoupeur(positionx, positiony, tempsexec, nbpiece, nbpiecesortie, couleur, taille, autorisation, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.tempsexec = tempsexec;
    this.nbpiece = nbpiece;
    this.nbpiecesortie = nbpiecesortie;
    //le nbpiecesortie correspond ici au nombre de piece en sortie
    this.couleur = couleur;
    this.taille = taille;
    this.autorisation = autorisation;
    this.etat = etat;
}

function assembleur(positionx, positiony, nbpiece, nbmaxpiece, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.etat = etat;
}

function desassembleur(positionx, positiony, nbpiece, nbmaxpiece, couleur, taille, qualite, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.etat = etat;
}



function init() {
    NbPiece = 0;
    NbSpawn = 3;
    NbRoute = 16;
    NbTesteur = 1;
    NbSeparateurP = 0;
    NbSeparateurS = 1;
    NbFeu = 1;
    NbEmpaqueteur = 1;
    NbDecoupeur = 1;
    NbAssembleur = 2;
    NbDesassembleur = 1;
}

var CLOCK = 10;
var random = 0;
var random2 = 0;
var verifrandom = 0;
var veriftemps = 1;

//VARIABLES A CHANGER
var nbdefaut = 100; //une piece sur nbdefaut a un défaut

//LES PIECES DISPONIBLES
var arrPiece = new Array(20); //20 pieces
var arrRoute = new Array(50); //50 routes
var arrSpawn = new Array(9); //9 spawn
var arrTesteur = new Array(5); //5 testeurs
var arrSeparateurP = new Array(5); //5 separateurs probabilistes
var arrSeparateurS = new Array(5); //5 separateurs sequenciels
var arrFeu = new Array(5); //5 feux
var arrEmpaqueteur = new Array(5); //5 empaqueteurs
var arrDecoupeur = new Array(5); //5 decoupeurs
var arrAssembleur = new Array(5); //5 assembleurs
var arrDesassembleur = new Array(5); //5 desassembleurs

//PIECES DESIREES

//LES SPAWNS
arrSpawn[0] = new spawn(45, 100, 0, 10);
arrSpawn[1] = new spawn(45, 270, 1, 10);
arrSpawn[2] = new spawn(45, 470, 2, 10);

//ROUTE BLEU
arrRoute[0] = new route(45, 100, 150, 1.5, 1);
arrTesteur[0] = new testeur(195, 100, 1, 0, 3, 1);
arrRoute[1] = new route(275, 100, 100, 1, 1);
arrRoute[9] = new route(375, 100, 110, 1.1, 2);
arrRoute[10] = new route(375, 210, 100, 1, 1);
arrAssembleur[1] = new assembleur(475, 230, 0, 2, 2);
arrRoute[11] = new route(555, 230, 100, 1, 1);
arrDecoupeur[0] = new decoupeur(655, 230, 2, 0, 4, 0, 0, 0, 3);
arrRoute[12] = new route(735, 230, 100, 1, 1);
arrEmpaqueteur[0] = new empaqueteur(835, 230, 0, 4, 0, 0, 4);
arrRoute[13] = new route(915, 230, 100, 1, 1);

//ROUTE ROUGE
arrRoute[2] = new route(45, 270, 150, 1.5, 1);
arrSeparateurS[0] = new separateursequence(195, 270, 0.1, 0, 3, [0, 1, 1, 0, 0, 0, 1, 1], 0, 5);
arrRoute[3] = new route(275, 250, 200, 2, 1);
arrRoute[4] = new route(275, 290, 150, 1.5, 1);
arrRoute[5] = new route(425, 290, 140, 1.4, 2);
arrRoute[6] = new route(425, 430, 20, 0.2, 1);

//ROUTE JAUNE
arrRoute[7] = new route(45, 470, 400, 3, 1);
arrFeu[0] = new feu(285, 470, 0, 5, 8, 1);
arrAssembleur[0] = new assembleur(445, 450, 0, 2, 6);
arrRoute[8] = new route(525, 450, 100, 1, 1);
arrDesassembleur[0] = new desassembleur(625, 450, 0, 2, 7);
arrRoute[14] = new route(705, 430, 100, 1, 1);
arrRoute[15] = new route(705, 470, 100, 1, 1);
//arrSeparateurP[0] = new separateurproba(805, 470, 0.1, 0, 2, 8);

//BOUTONS
var btn1 = document.createElement("BUTTON");
document.body.appendChild(btn1);
btn1.innerHTML = "Ajouter piece bleue";
btn1.addEventListener("click", function () {
    for (var i = 0; i < NbSpawn; i++) {
        if (arrSpawn[i].couleur == 0) {
            arrPiece[NbPiece] = new piece(arrSpawn[i].positionx, arrSpawn[i].positiony, arrSpawn[i].taille, 0, verifrandom2, 0, 0);
            NbPiece++;
        }
    }
});
btn1.style.position = "absolute";
btn1.style.top = "20px";
btn1.style.left = "1270px";

var btn2 = document.createElement("BUTTON");
document.body.appendChild(btn2);
btn2.innerHTML = "Ajouter piece rouge";
btn2.addEventListener("click", function () {
    for (var i = 0; i < NbSpawn; i++) {
        if (arrSpawn[i].couleur == 1) {
            arrPiece[NbPiece] = new piece(arrSpawn[i].positionx, arrSpawn[i].positiony, arrSpawn[i].taille, 1, verifrandom2, 0, 0);
            NbPiece++;
        }
    }
});
btn2.style.position = "absolute";
btn2.style.top = "50px";
btn2.style.left = "1270px";

var btn3 = document.createElement("BUTTON");
document.body.appendChild(btn3);
btn3.innerHTML = "Ajouter piece jaune";
btn3.addEventListener("click", function () {
    for (var i = 0; i < NbSpawn; i++) {
        if (arrSpawn[i].couleur == 2) {
            arrPiece[NbPiece] = new piece(arrSpawn[i].positionx, arrSpawn[i].positiony, arrSpawn[i].taille, 2, verifrandom2, 0, 0);
            NbPiece++;
        }
    }
});
btn3.style.position = "absolute";
btn3.style.top = "80px";
btn3.style.left = "1270px";

var btn4 = document.createElement("BUTTON");
document.body.appendChild(btn4);
btn4.innerHTML = "Stopper la simulation";
btn4.addEventListener("click", function () {
    veriftemps = 0;
});
btn4.style.position = "absolute";
btn4.style.top = "870px";
btn4.style.left = "625px";

var btn5 = document.createElement("BUTTON");
document.body.appendChild(btn5);
btn5.innerHTML = "Reprendre";
btn5.addEventListener("click", function () {
    veriftemps = 1;
});
btn5.style.position = "absolute";
btn5.style.top = "870px";
btn5.style.left = "775px";


//LA FONCTION CLOCK
function clock() {
    document.getElementById('canvas');
    var ctx = document.getElementById('canvas').getContext('2d');
    ctx.clearRect(0, 0, 1900, 880);

    random = Math.floor(Math.random() * 2); //random entre 0 et 1 (50%)
    random2 = Math.floor(Math.random() * 100) % nbdefaut; //random entre 0 et nbdefaut-1 (donc nbdefaut choix possibles)
    if (random2 == 0) {
        verifrandom2 = 1
    }
    else {
        verifrandom2 = 0
    }

    //DELIMITATION DU CANVAS
    ctx.strokeStyle = 'black';
    ctx.strokeRect(0, 0,1400, 900);


    //CONSTRUCTION DES PIECES
    for (var i = 0; i < NbPiece; i++) {
        if (arrPiece[i].couleur == 0) {
            ctx.fillStyle = 'royalblue';
        }
        else if (arrPiece[i].couleur == 1) {
            ctx.fillStyle = 'crimson';
        }
        else if (arrPiece[i].couleur == 2) {
            ctx.fillStyle = 'gold';
        }
        else if (arrPiece[i].couleur == 3) {
            ctx.fillStyle = 'blueviolet';
        }
        else if (arrPiece[i].couleur == 4) {
            ctx.fillStyle = 'yellowgreen';
        }
        else if (arrPiece[i].couleur == 5) {
            ctx.fillStyle = 'darkorange';
        }
        if (arrPiece[i].qualite == 1) {
            ctx.fillStyle = 'black';
        }
        if (arrPiece[i].etat != 0) {
            ctx.fillStyle = 'white';
        }
        ctx.fillRect(arrPiece[i].positionx, arrPiece[i].positiony - arrPiece[i].taille, arrPiece[i].taille, arrPiece[i].taille);
    }

    //CONSTRUCTION DES SPAWN
    for (var i = 0; i < NbSpawn; i++) {
        if (arrSpawn[i].couleur == 0) {
            ctx.fillStyle = 'royalblue';
        }
        else if (arrSpawn[i].couleur == 1) {
            ctx.fillStyle = 'crimson';
        }
        else if (arrSpawn[i].couleur == 2) {
            ctx.fillStyle = 'gold';
        }
        ctx.fillRect(arrSpawn[i].positionx - 3, arrSpawn[i].positiony - 3, 6, 6);
    }

    //CONSTRUCTION DES ROUTES
    ctx.strokeStyle = 'black';
    for (var i = 0; i < NbRoute; i++) {
        ctx.moveTo(arrRoute[i].positionx, arrRoute[i].positiony);
        if (arrRoute[i].orientation == 1) {
            ctx.lineTo(arrRoute[i].positionx + arrRoute[i].longueur, arrRoute[i].positiony);
        }
        else {
            ctx.lineTo(arrRoute[i].positionx, arrRoute[i].positiony + arrRoute[i].longueur);
        }
        ctx.stroke();
    }
    ctx.moveTo(0, 0);
    ctx.lineTo(1, 0);
    ctx.stroke();

    ctx.fillStyle = 'black';
    ctx.font = '12px sans-serif';
    ctx.textAlign = "center";

    //CONSTRUCTION DES TESTEURS
    ctx.strokeStyle = 'darkviolet';
    for (var i = 0; i < NbTesteur; i++) {
        ctx.strokeRect(arrTesteur[i].positionx, arrTesteur[i].positiony - 50, 80, 100);
        ctx.fillRect(arrTesteur[i].positionx - 6, arrTesteur[i].positiony - 3, 6, 6);
        ctx.fillRect(arrTesteur[i].positionx + 80, arrTesteur[i].positiony - 3, 6, 6);
        ctx.fillText("Testeur", arrTesteur[i].positionx + 40, arrTesteur[i].positiony + 65, 80);
        ctx.fillText("Pieces :", arrTesteur[i].positionx + 40, arrTesteur[i].positiony - 25, 80);
        ctx.fillText(arrTesteur[i].nbpiece, arrTesteur[i].positionx + 30, arrTesteur[i].positiony - 10, 20);
        ctx.fillText("/", arrTesteur[i].positionx + 40, arrTesteur[i].positiony - 10, 80);
        ctx.fillText(arrTesteur[i].nbmaxpiece, arrTesteur[i].positionx + 50, arrTesteur[i].positiony - 10, 20);
        ctx.fillText("Temps :", arrTesteur[i].positionx + 40, arrTesteur[i].positiony + 15, 80);
        ctx.fillText(arrTesteur[i].tempsexec, arrTesteur[i].positionx + 35, arrTesteur[i].positiony + 30, 10);
        ctx.fillText("s", arrTesteur[i].positionx + 45, arrTesteur[i].positiony + 30, 10);
    }

    //CONSTRUCTION DES SEPARATEURS PROBABILISTES
    ctx.strokeStyle = 'seagreen';
    for (var i = 0; i < NbSeparateurP; i++) {
        ctx.strokeRect(arrSeparateurP[i].positionx, arrSeparateurP[i].positiony - 50, 80, 100);
        ctx.fillRect(arrSeparateurP[i].positionx - 6, arrSeparateurP[i].positiony - 3, 6, 6);
        ctx.fillRect(arrSeparateurP[i].positionx + 80, arrSeparateurP[i].positiony - 23, 6, 6);
        ctx.fillRect(arrSeparateurP[i].positionx + 80, arrSeparateurP[i].positiony + 17, 6, 6);
        ctx.fillText("Separateur", arrSeparateurP[i].positionx + 40, arrSeparateurP[i].positiony + 65, 80);
        ctx.fillText("probabiliste", arrSeparateurP[i].positionx + 40, arrSeparateurP[i].positiony + 80, 80);
    }

    //CONSTRUCTION DES SEPARATEURS SEQUENTIELS
    ctx.strokeStyle = 'limegreen';
    for (var i = 0; i < NbSeparateurS; i++) {
        ctx.strokeRect(arrSeparateurS[i].positionx, arrSeparateurS[i].positiony - 50, 80, 100);
        ctx.fillRect(arrSeparateurS[i].positionx - 6, arrSeparateurS[i].positiony - 3, 6, 6);
        ctx.fillRect(arrSeparateurS[i].positionx + 80, arrSeparateurS[i].positiony - 23, 6, 6);
        ctx.fillRect(arrSeparateurS[i].positionx + 80, arrSeparateurS[i].positiony + 17, 6, 6);
        ctx.fillText("Separateur", arrSeparateurS[i].positionx + 40, arrSeparateurS[i].positiony + 65, 80);
        ctx.fillText("sequentiel", arrSeparateurS[i].positionx + 40, arrSeparateurS[i].positiony + 80, 80);
        ctx.fillText("0", arrSeparateurS[i].positionx + 70, arrSeparateurS[i].positiony - 16, 20);
        ctx.fillText("1", arrSeparateurS[i].positionx + 70, arrSeparateurS[i].positiony + 24, 20);
        ctx.strokeStyle = 'black';
        if (arrSeparateurS[i].sequence[arrSeparateurS[i].etapesequence] == 0) {
            ctx.moveTo(arrSeparateurS[i].positionx + 10, arrSeparateurS[i].positiony);
            ctx.lineTo(arrSeparateurS[i].positionx + 60, arrSeparateurS[i].positiony - 20);
            ctx.stroke();
        }
        else if (arrSeparateurS[i].sequence[arrSeparateurS[i].etapesequence] == 1) {
            ctx.moveTo(arrSeparateurS[i].positionx + 10, arrSeparateurS[i].positiony);
            ctx.lineTo(arrSeparateurS[i].positionx + 60, arrSeparateurS[i].positiony + 20);
            ctx.stroke();
        }

    }

    //CONSTRUCTION DES EMPAQUETEURS
    ctx.strokeStyle = 'red';
    for (var i = 0; i < NbEmpaqueteur; i++) {
        ctx.strokeRect(arrEmpaqueteur[i].positionx, arrEmpaqueteur[i].positiony - 50, 80, 100);
        ctx.fillRect(arrEmpaqueteur[i].positionx - 6, arrEmpaqueteur[i].positiony - 3, 6, 6);
        ctx.fillRect(arrEmpaqueteur[i].positionx + 80, arrEmpaqueteur[i].positiony - 3, 6, 6);
        ctx.fillText("Empaqueteur", arrEmpaqueteur[i].positionx + 40, arrEmpaqueteur[i].positiony + 65, 80);
        ctx.fillText("Pieces :", arrEmpaqueteur[i].positionx + 40, arrEmpaqueteur[i].positiony - 5, 80);
        ctx.fillText(arrEmpaqueteur[i].nbpiece, arrEmpaqueteur[i].positionx + 30, arrEmpaqueteur[i].positiony + 10, 20);
        ctx.fillText("/", arrEmpaqueteur[i].positionx + 40, arrEmpaqueteur[i].positiony + 10, 80);
        ctx.fillText(arrEmpaqueteur[i].nbmaxpiece, arrEmpaqueteur[i].positionx + 50, arrEmpaqueteur[i].positiony + 10, 20);
    }

    //CONSTRUCTION DES DECOUPEURS
    ctx.strokeStyle = 'orangered';
    for (var i = 0; i < NbDecoupeur; i++) {
        ctx.strokeRect(arrDecoupeur[i].positionx, arrDecoupeur[i].positiony - 50, 80, 100);
        ctx.fillRect(arrDecoupeur[i].positionx - 6, arrDecoupeur[i].positiony - 3, 6, 6);
        ctx.fillRect(arrDecoupeur[i].positionx + 80, arrDecoupeur[i].positiony - 3, 6, 6);
        ctx.fillText("Decoupeur", arrDecoupeur[i].positionx + 40, arrDecoupeur[i].positiony + 65, 80);
        ctx.fillText("Pieces :", arrDecoupeur[i].positionx + 40, arrDecoupeur[i].positiony - 25, 80);
        ctx.fillText(arrDecoupeur[i].nbpiece, arrDecoupeur[i].positionx + 30, arrDecoupeur[i].positiony - 10, 20);
        ctx.fillText("/", arrDecoupeur[i].positionx + 40, arrDecoupeur[i].positiony - 10, 80);
        ctx.fillText(arrDecoupeur[i].nbpiecesortie, arrDecoupeur[i].positionx + 50, arrDecoupeur[i].positiony - 10, 20);
        for (var j = 0; j < NbPiece; j++) {
            if (arrPiece[j].etat == arrDecoupeur[i].etat && arrDecoupeur[i].tempsexec - (arrPiece[j].horloge / 100) >= 0) {
                ctx.fillText("Temps restant:", arrDecoupeur[i].positionx + 40, arrDecoupeur[i].positiony + 15, 80);
                ctx.fillText((arrDecoupeur[i].tempsexec - (arrPiece[j].horloge / 100)).toFixed(1), arrDecoupeur[i].positionx + 33, arrDecoupeur[i].positiony + 30, 40);
                ctx.fillText("s", arrDecoupeur[i].positionx + 47, arrDecoupeur[i].positiony + 30, 10);
            }
            else if (arrPiece[j].etat == arrDecoupeur[i].etat && arrDecoupeur[i].tempsexec - (arrPiece[j].horloge / 100) < 0) {
                ctx.fillText("Temps restant:", arrDecoupeur[i].positionx + 40, arrDecoupeur[i].positiony + 15, 80);
                ctx.fillText("0", arrDecoupeur[i].positionx + 33, arrDecoupeur[i].positiony + 30, 40);
                ctx.fillText("s", arrDecoupeur[i].positionx + 47, arrDecoupeur[i].positiony + 30, 10);
            }
        }
    }

    //CONSTRUCTION DES ASSEMBLEURS
    ctx.strokeStyle = 'dodgerblue';
    for (var i = 0; i < NbAssembleur; i++) {
        ctx.strokeRect(arrAssembleur[i].positionx, arrAssembleur[i].positiony - 50, 80, 100);
        ctx.fillRect(arrAssembleur[i].positionx - 6, arrAssembleur[i].positiony - 23, 6, 6);
        ctx.fillRect(arrAssembleur[i].positionx - 6, arrAssembleur[i].positiony + 17, 6, 6);
        ctx.fillRect(arrAssembleur[i].positionx + 80, arrAssembleur[i].positiony - 3, 6, 6);
        ctx.fillText("Assembleur", arrAssembleur[i].positionx + 40, arrAssembleur[i].positiony + 65, 80);
        ctx.fillText(arrAssembleur[i].nbpiece, arrAssembleur[i].positionx + 30, arrAssembleur[i].positiony - 15, 20);
        ctx.fillText("/", arrAssembleur[i].positionx + 40, arrAssembleur[i].positiony - 15, 80);
        ctx.fillText(arrAssembleur[i].nbmaxpiece, arrAssembleur[i].positionx + 50, arrAssembleur[i].positiony - 15, 20);
        for (var j = 0; j < NbPiece; j++) {
            if (arrAssembleur[i].etat == arrPiece[j].etat) {
                if (arrPiece[j].couleur == 0) {
                    ctx.fillStyle = 'royalblue';
                }
                else if (arrPiece[j].couleur == 1) {
                    ctx.fillStyle = 'crimson';
                }
                else if (arrPiece[j].couleur == 2) {
                    ctx.fillStyle = 'gold';
                }
                ctx.fillRect(arrAssembleur[i].positionx + 15, arrAssembleur[i].positiony + 25, 10, 10);
                ctx.fillStyle = 'black';
                ctx.fillText("+", arrAssembleur[i].positionx + 40, arrAssembleur[i].positiony + 35, 20);
                for (var k = 0; k < NbPiece; k++) {
                    if (arrAssembleur[i].etat == arrPiece[k].etat && k != j) {
                        if (arrPiece[k].couleur == 0) {
                            ctx.fillStyle = 'royalblue';
                        }
                        else if (arrPiece[k].couleur == 1) {
                            ctx.fillStyle = 'crimson';
                        }
                        else if (arrPiece[k].couleur == 2) {
                            ctx.fillStyle = 'gold';
                        }
                        ctx.fillRect(arrAssembleur[i].positionx + 55, arrAssembleur[i].positiony + 25, 10, 10);
                    }
                }
            }
        }
    }
    ctx.fillStyle = 'black';

    //CONSTRUCTION DES DESASSEMBLEURS
    ctx.strokeStyle = 'deepskyblue';
    for (var i = 0; i < NbDesassembleur; i++) {
        ctx.strokeRect(arrDesassembleur[i].positionx, arrDesassembleur[i].positiony - 50, 80, 100);
        ctx.fillRect(arrDesassembleur[i].positionx - 6, arrDesassembleur[i].positiony - 3, 6, 6);
        ctx.fillRect(arrDesassembleur[i].positionx + 80, arrDesassembleur[i].positiony - 23, 6, 6);
        ctx.fillRect(arrDesassembleur[i].positionx + 80, arrDesassembleur[i].positiony + 17, 6, 6);
        ctx.fillText("Desassembleur", arrDesassembleur[i].positionx + 40, arrDesassembleur[i].positiony + 65, 80);
    }



    //CONSTRUCTION DES FEUX
    for (var i = 0; i < NbFeu; i++) {
        ctx.fillStyle = 'gray';
        ctx.fillRect(arrFeu[i].positionx - 40, arrFeu[i].positiony + 10, 30, 55);
        if (arrFeu[i].etat == 0) {
            ctx.beginPath();
            ctx.fillStyle = 'orangered';
            ctx.arc(arrFeu[i].positionx - 25, arrFeu[i].positiony + 50, 10, 0, 2 * Math.PI);
            ctx.fill();
            ctx.fillStyle = 'black';
            ctx.fillRect(arrFeu[i].positionx - 3, arrFeu[i].positiony - 3, 6, 6);
        }
        else if (arrFeu[i].etat == 1) {
            ctx.beginPath();
            ctx.fillStyle = 'limegreen';
            ctx.arc(arrFeu[i].positionx - 25, arrFeu[i].positiony + 25, 10, 0, 2 * Math.PI);
            ctx.fill();
        }
    }


    if (veriftemps == 1) {


        //INTERACTION ENTRE LES PIECES ET LES ROUTES (+ LES FEUX + LES PIECES ENTRE ELLES)
        for (var i = 0; i < NbPiece; i++) {
            for (var j = 0; j < NbRoute; j++) {
                if (arrPiece[i].positionx < arrRoute[j].positionx + arrRoute[j].longueur && arrPiece[i].positionx >= arrRoute[j].positionx && arrPiece[i].positiony == arrRoute[j].positiony && arrRoute[j].orientation == 1) {
                    arrPiece[i].positionx = arrPiece[i].positionx + arrRoute[j].longueur / (arrRoute[j].temps * 100);
                    for (var k = 0; k < NbFeu; k++) {
                        if (arrPiece[i].positionx + arrPiece[i].taille >= arrFeu[k].positionx && arrPiece[i].positionx + arrPiece[i].taille < arrFeu[k].positionx + arrRoute[j].longueur / (arrRoute[j].temps * 100) && arrPiece[i].positiony == arrFeu[k].positiony && arrFeu[k].etat == 0) {
                            arrPiece[i].positionx = arrPiece[i].positionx - arrRoute[j].longueur / (arrRoute[j].temps * 100);
                        }
                    }
                    for (var k = 0; k < NbPiece; k++) {
                        if (arrPiece[i].positionx + arrPiece[i].taille < arrPiece[k].positionx && arrPiece[i].positionx + arrPiece[i].taille > arrPiece[k].positionx - 5 && arrPiece[i].positiony == arrPiece[k].positiony) {
                            arrPiece[i].positionx = arrPiece[i].positionx - arrRoute[j].longueur / (arrRoute[j].temps * 100);
                        }
                    }
                }
                else if (arrPiece[i].positiony < arrRoute[j].positiony + arrRoute[j].longueur && arrPiece[i].positiony >= arrRoute[j].positiony && arrPiece[i].positionx == arrRoute[j].positionx && arrRoute[j].orientation == 2) {
                    arrPiece[i].positiony = arrPiece[i].positiony + arrRoute[j].longueur / (arrRoute[j].temps * 100);
                    for (var k = 0; k < NbFeu; k++) {
                        if (arrPiece[i].positiony + arrPiece[i].taille >= arrFeu[k].positiony && arrPiece[i].positiony + arrPiece[i].taille < arrFeu[k].positiony + arrRoute[j].longueur / (arrRoute[j].temps * 100) && arrPiece[i].positionx == arrFeu[k].positionx && arrFeu[k].etat == 0) {
                            arrPiece[i].positiony = arrPiece[i].positiony - arrRoute[j].longueur / (arrRoute[j].temps * 100);
                        }
                    }
                    for (var k = 0; k < NbPiece; k++) {
                        if (arrPiece[i].positiony + arrPiece[i].taille < arrPiece[k].positiony && arrPiece[i].positiony + arrPiece[i].taille > arrPiece[k].positiony - 5 && arrPiece[i].positionx == arrPiece[k].positionx) {
                            arrPiece[i].positiony = arrPiece[i].positiony - arrRoute[j].longueur / (arrRoute[j].temps * 100);
                        }
                    }
                }
            }
        }


        //INTERACTION DE FEUX
        for (var i = 0; i < NbFeu; i++) {
            if (arrFeu[i].etat == 0) {
                if (arrFeu[i].horloge < arrFeu[i].tempsrouge * 100) {
                    arrFeu[i].horloge++;
                }
                if (arrFeu[i].horloge == arrFeu[i].tempsrouge * 100) {
                    arrFeu[i].horloge = 0;
                    arrFeu[i].etat = 1;
                }
            }
            else if (arrFeu[i].etat == 1) {
                if (arrFeu[i].horloge < arrFeu[i].tempsvert * 100) {
                    arrFeu[i].horloge++;
                }
                if (arrFeu[i].horloge == arrFeu[i].tempsvert * 100) {
                    arrFeu[i].horloge = 0;
                    arrFeu[i].etat = 0;
                }
            }
        }

        //INTERACTION ENTRE LES PIECES ET LES TESTEURS
        for (var i = 0; i < NbPiece; i++) {
            for (var j = 0; j < NbTesteur; j++) {
                if (arrPiece[i].positionx + arrPiece[i].taille >= arrTesteur[j].positionx && arrPiece[i].positionx < arrTesteur[j].positionx + 5 && arrPiece[i].positiony <= arrTesteur[j].positiony && arrPiece[i].positiony == arrTesteur[j].positiony && arrTesteur[j].nbpiece < arrTesteur[j].nbmaxpiece) {
                    arrPiece[i].positionx = arrTesteur[j].positionx + 5;
                    arrTesteur[j].nbpiece++;
                    arrPiece[i].etat = arrTesteur[j].etat;
                }
                else if (arrPiece[i].etat == arrTesteur[j].etat && arrPiece[i].qualite == 0 && arrPiece[i].horloge > arrTesteur[j].tempsexec * 100) {
                    arrPiece[i].etat = 0;
                    arrPiece[i].horloge = 0;
                    arrPiece[i].positionx = arrTesteur[j].positionx + 80;
                    arrTesteur[j].nbpiece--;
                }
                else if (arrPiece[i].etat == arrTesteur[j].etat && arrPiece[i].qualite == 1 && arrPiece[i].horloge > arrTesteur[j].tempsexec * 100) {
                    arrPiece.splice(i, 1);
                    arrTesteur[j].nbpiece--;
                    NbPiece--;
                }
                else if (arrPiece[i].etat == arrTesteur[j].etat) {
                    arrPiece[i].horloge++;
                }
            }
        }

        //INTERACTION ENTRE LES PIECES ET LES SEPARATEURS PROBABILISTES
        for (var i = 0; i < NbPiece; i++) {
            for (var j = 0; j < NbSeparateurP; j++) {
                if (arrPiece[i].positionx + arrPiece[i].taille >= arrSeparateurP[j].positionx && arrPiece[i].positionx < arrSeparateurP[j].positionx + 5 && arrPiece[i].positiony == arrSeparateurP[j].positiony && arrSeparateurP[j].nbpiece < arrSeparateurP[j].nbmaxpiece) {
                    arrPiece[i].positionx = arrSeparateurP[j].positionx + 5;
                    arrSeparateurP[j].nbpiece++;
                    arrPiece[i].etat = arrSeparateurP[j].etat;
                }
                else if (arrPiece[i].etat == arrSeparateurP[j].etat && arrPiece[i].horloge > arrSeparateurP[j].tempsexec * 100 && random == 0) {
                    arrPiece[i].etat = 0;
                    arrPiece[i].horloge = 0;
                    arrPiece[i].positionx = arrSeparateurP[j].positionx + 80;
                    arrPiece[i].positiony += -20;
                    arrSeparateurP[j].nbpiece--;
                }
                else if (arrPiece[i].etat == arrSeparateurP[j].etat && arrPiece[i].horloge > arrSeparateurP[j].tempsexec * 100 && random == 1) {
                    arrPiece[i].etat = 0;
                    arrPiece[i].horloge = 0;
                    arrPiece[i].positionx = arrSeparateurP[j].positionx + 80;
                    arrPiece[i].positiony += 20;
                    arrSeparateurP[j].nbpiece--;
                }
                else if (arrPiece[i].etat == arrSeparateurP[j].etat) {
                    arrPiece[i].horloge++;
                }
            }
        }

        //INTERACTION ENTRE LES PIECES ET LES SEPARATEURS SEQUENCIELS
        for (var i = 0; i < NbPiece; i++) {
            for (var j = 0; j < NbSeparateurS; j++) {
                if (arrPiece[i].positionx + arrPiece[i].taille >= arrSeparateurS[j].positionx && arrPiece[i].positionx < arrSeparateurS[j].positionx + 5 && arrPiece[i].positiony == arrSeparateurS[j].positiony && arrSeparateurS[j].nbpiece < arrSeparateurS[j].nbmaxpiece) {
                    arrPiece[i].positionx = arrSeparateurS[j].positionx + 5;
                    arrSeparateurS[j].nbpiece++;
                    arrPiece[i].etat = arrSeparateurS[j].etat;
                }
                else if (arrPiece[i].etat == arrSeparateurS[j].etat && arrPiece[i].horloge > arrSeparateurS[j].tempsexec * 100 && arrSeparateurS[j].sequence[arrSeparateurS[j].etapesequence] == 0) {
                    arrPiece[i].etat = 0;
                    arrPiece[i].horloge = 0;
                    arrPiece[i].positionx = arrSeparateurS[j].positionx + 80;
                    arrPiece[i].positiony += -20;
                    arrSeparateurS[j].nbpiece--;
                    arrSeparateurS[j].etapesequence = (arrSeparateurS[j].etapesequence + 1) % arrSeparateurS[j].sequence.length
                }
                else if (arrPiece[i].etat == arrSeparateurS[j].etat && arrPiece[i].horloge > arrSeparateurS[j].tempsexec * 100 && arrSeparateurS[j].sequence[arrSeparateurS[j].etapesequence] == 1) {
                    arrPiece[i].etat = 0;
                    arrPiece[i].horloge = 0;
                    arrPiece[i].positionx = arrSeparateurS[j].positionx + 80;
                    arrPiece[i].positiony += 20;
                    arrSeparateurS[j].nbpiece--;
                    arrSeparateurS[j].etapesequence = (arrSeparateurS[j].etapesequence + 1) % arrSeparateurS[j].sequence.length
                }
                else if (arrPiece[i].etat == arrSeparateurS[j].etat) {
                    arrPiece[i].horloge++;
                }
            }
        }

        //INTERACTION ENTRE LES PIECES ET LES ASSEMBLEURS
        for (var i = 0; i < NbPiece; i++) {
            for (var j = 0; j < NbAssembleur; j++) {
                if (arrPiece[i].positiony >= arrAssembleur[j].positiony - 30 && arrPiece[i].positiony <= arrAssembleur[j].positiony + 30 && arrPiece[i].positionx + arrPiece[i].taille >= arrAssembleur[j].positionx && arrPiece[i].positionx < arrAssembleur[j].positionx + 5 && arrAssembleur[j].nbpiece < arrAssembleur[j].nbmaxpiece) {
                    if (arrAssembleur[j].nbpiece == 0) {
                        arrPiece[i].positionx = arrAssembleur[j].positionx + 5;
                        arrAssembleur[j].nbpiece++;
                        arrPiece[i].etat = arrAssembleur[j].etat;
                    }
                    else if (arrAssembleur[j].nbpiece == 1) {
                        for (var k = 0; k < NbPiece; k++) {
                            if (arrPiece[k].etat == arrAssembleur[j].etat && arrPiece[i].couleur != arrPiece[k].couleur) {
                                arrPiece[i].positionx = arrAssembleur[j].positionx + 80;
                                arrAssembleur[j].nbpiece++;
                                arrPiece[i].etat = arrAssembleur[j].etat;
                            }
                        }
                    }
                }
                if (arrAssembleur[j].nbpiece == 2) {
                    for (var k = 0; k < NbPiece; k++) {
                        if (arrPiece[i].etat = arrAssembleur[j].etat && arrPiece[k].etat == arrAssembleur[j].etat && i != k) {
                            if ((arrPiece[i].couleur == 0 && arrPiece[k].couleur == 1) || (arrPiece[i].couleur == 1 && arrPiece[k].couleur == 0)) {
                                arrPiece[NbPiece] = new piece(arrAssembleur[j].positionx + 80, arrAssembleur[j].positiony, 10, 3, 0, 0, 0);
                                if (i > k) {
                                    arrPiece.splice(i, 1);
                                    arrPiece.splice(k, 1);
                                }
                                else {
                                    arrPiece.splice(k, 1);
                                    arrPiece.splice(i, 1);
                                }
                                NbPiece--;
                                arrAssembleur[j].nbpiece += -2;
                                i = NbPiece;
                                k = NbPiece;
                                j = NbAssembleur;
                            }
                            else if ((arrPiece[i].couleur == 2 && arrPiece[k].couleur == 0) || (arrPiece[i].couleur == 0 && arrPiece[k].couleur == 2)) {
                                arrPiece[NbPiece] = new piece(arrAssembleur[j].positionx + 80, arrAssembleur[j].positiony, 10, 4, 0, 0, 0);
                                if (i > k) {
                                    arrPiece.splice(i, 1);
                                    arrPiece.splice(k, 1);
                                }
                                else {
                                    arrPiece.splice(k, 1);
                                    arrPiece.splice(i, 1);
                                }
                                NbPiece--;
                                arrAssembleur[j].nbpiece += -2;
                                i = NbPiece;
                                k = NbPiece;
                                j = NbAssembleur;
                            }
                            else if ((arrPiece[i].couleur == 2 && arrPiece[k].couleur == 1) || (arrPiece[i].couleur == 1 && arrPiece[k].couleur == 2)) {
                                arrPiece[NbPiece] = new piece(arrAssembleur[j].positionx + 80, arrAssembleur[j].positiony, 10, 5, 0, 0, 0);
                                if (i > k) {
                                    arrPiece.splice(i, 1);
                                    arrPiece.splice(k, 1);
                                }
                                else {
                                    arrPiece.splice(k, 1);
                                    arrPiece.splice(i, 1);
                                }
                                NbPiece--;
                                arrAssembleur[j].nbpiece += -2;
                                i = NbPiece;
                                k = NbPiece;
                                j = NbAssembleur;
                            }
                        }
                    }
                }
            }
        }

        //INTERACTION ENTRE LES PIECES ET LES DESASSEMBLEURS
        for (var i = 0; i < NbPiece; i++) {
            for (var j = 0; j < NbDesassembleur; j++) {
                if (arrPiece[i].positionx + arrPiece[i].taille >= arrDesassembleur[j].positionx && arrPiece[i].positionx < arrDesassembleur[j].positionx + 10 && arrPiece[i].positiony == arrDesassembleur[j].positiony) {
                    arrDesassembleur[j].taille = arrPiece[i].taille;
                    arrDesassembleur[j].couleur = arrPiece[i].couleur;
                    arrDesassembleur[j].qualite = arrPiece[i].qualite;
                    arrPiece.splice(i, 1);
                    NbPiece--;
                }
                if (arrDesassembleur[j].couleur == 3) {
                    arrPiece[NbPiece] = new piece(arrDesassembleur[j].positionx + 80, arrDesassembleur[j].positiony - 20, arrDesassembleur[j].taille, 0, arrDesassembleur[j].qualite, 0, 0);
                    arrPiece[NbPiece + 1] = new piece(arrDesassembleur[j].positionx + 80, arrDesassembleur[j].positiony + 20, arrDesassembleur[j].taille, 1, arrDesassembleur[j].qualite, 0, 0);
                    NbPiece += 2;
                    arrDesassembleur[j].couleur = 0;
                }
                else if (arrDesassembleur[j].couleur == 4) {
                    arrPiece[NbPiece] = new piece(arrDesassembleur[j].positionx + 80, arrDesassembleur[j].positiony - 20, arrDesassembleur[j].taille, 0, arrDesassembleur[j].qualite, 0, 0);
                    arrPiece[NbPiece + 1] = new piece(arrDesassembleur[j].positionx + 80, arrDesassembleur[j].positiony + 20, arrDesassembleur[j].taille, 2, arrDesassembleur[j].qualite, 0, 0);
                    NbPiece += 2;
                    arrDesassembleur[j].couleur = 0;
                }
                else if (arrDesassembleur[j].couleur == 5) {
                    arrPiece[NbPiece] = new piece(arrDesassembleur[j].positionx + 80, arrDesassembleur[j].positiony - 20, arrDesassembleur[j].taille, 1, arrDesassembleur[j].qualite, 0, 0);
                    arrPiece[NbPiece + 1] = new piece(arrDesassembleur[j].positionx + 80, arrDesassembleur[j].positiony + 20, arrDesassembleur[j].taille, 2, arrDesassembleur[j].qualite, 0, 0);
                    NbPiece += 2;
                    arrDesassembleur[j].couleur = 0;
                }
            }
        }


        //INTERACTION ENTRE LES PIECES ET LES EMPAQUETEURS
        for (var i = 0; i < NbPiece; i++) {
            for (var j = 0; j < NbEmpaqueteur; j++) {
                if (arrPiece[i].positionx + arrPiece[i].taille >= arrEmpaqueteur[j].positionx && arrPiece[i].positionx < arrEmpaqueteur[j].positionx + 10 && arrPiece[i].positiony == arrEmpaqueteur[j].positiony) {
                    arrEmpaqueteur[j].couleur = arrPiece[i].couleur;
                    arrEmpaqueteur[j].taille = arrPiece[i].taille;
                    arrPiece.splice(i, 1);
                    NbPiece--;
                    arrEmpaqueteur[j].nbpiece++;
                }
                if (arrEmpaqueteur[j].nbpiece == arrEmpaqueteur[j].nbmaxpiece) {
                    arrEmpaqueteur[j].nbpiece = 0;
                    arrPiece[NbPiece] = new piece(arrEmpaqueteur[j].positionx + 80, arrEmpaqueteur[j].positiony, arrEmpaqueteur[j].taille + arrEmpaqueteur[j].nbmaxpiece, arrEmpaqueteur[j].couleur, 0, 0, 0);
                    NbPiece++;
                }
            }
        }

        //INTERACTION ENTRE LES PIECES ET LES DECOUPEURS
        for (var i = 0; i < NbPiece; i++) {
            for (var j = 0; j < NbDecoupeur; j++) {
                arrDecoupeur[j].autorisation = 1;
                for (var k = 0; k < NbPiece; k++) {
                    if (arrPiece[k].positionx < arrDecoupeur[j].positionx + 85 + arrDecoupeur[j].taille - arrDecoupeur[j].nbpiecesortie && arrPiece[k].positionx >= arrDecoupeur[j].positionx + 80 && arrPiece[k].positiony == arrDecoupeur[j].positiony) {
                        arrDecoupeur[j].autorisation = 0;
                    }
                }
                if (arrPiece[i].positionx + arrPiece[i].taille >= arrDecoupeur[j].positionx && arrPiece[i].positionx < arrDecoupeur[j].positionx + 5 && arrPiece[i].positiony == arrDecoupeur[j].positiony && arrDecoupeur[j].nbpiece == 0) {
                    arrPiece[i].positionx = arrDecoupeur[j].positionx + 5;
                    arrDecoupeur[j].couleur = arrPiece[i].couleur;
                    arrDecoupeur[j].taille = arrPiece[i].taille;
                    arrPiece[i].etat = arrDecoupeur[j].etat;
                    arrDecoupeur[j].nbpiece = arrDecoupeur[j].nbpiecesortie;
                }
                if (arrDecoupeur[j].nbpiece > 0 && arrDecoupeur[j].autorisation == 1 && arrPiece[i].horloge > arrDecoupeur[j].tempsexec * 100) {
                    arrPiece[NbPiece] = new piece(arrDecoupeur[j].positionx + 80, arrDecoupeur[j].positiony, arrDecoupeur[j].taille - arrDecoupeur[j].nbpiecesortie, arrDecoupeur[j].couleur, 0, 0, 0);
                    arrDecoupeur[j].nbpiece--;
                    NbPiece++;
                }
                if (arrPiece[i].etat == arrDecoupeur[j].etat) {
                    arrPiece[i].horloge++;
                }
                if (arrPiece[i].etat == arrDecoupeur[j].etat && arrDecoupeur[j].nbpiece == 0) {
                    arrPiece[i].horloge = 0;
                    arrPiece.splice(i, 1);
                    NbPiece--;
                }
            }
        }
    }

    setTimeout(function () { clock() }, CLOCK);
}
window.onload = init;
window.requestAnimationFrame(clock);