function piece(positionx, positiony, taille, couleur, qualite, horloge, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.taille = taille;
    this.couleur = couleur;
    //0=bleu
    //1=rouge
    //2=jaune
    //3=violet
    //4=vert
    //5=orange
    this.qualite = qualite;
    //qualite 0 = bien
    //qualite 1 = defectueux
    this.horloge = horloge;
    this.etat = etat;
    //etat 0 = normal
    //autre etat = correspond au bloc dans lequel il se trouve
}

function route(positionx, positiony, longueur, temps, orientation) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.longueur = longueur;
    this.temps = temps;
    //mettre le temps en seconde
    this.orientation = orientation;
    //orientation 1 = horizontal
    //orientation 2 = vertical
}

function spawn(positionx, positiony, couleur, taille) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.couleur = couleur;
    this.taille = taille;
}

function testeur(positionx, positiony, tempsexec, nbpiece, nbmaxpiece, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.tempsexec = tempsexec;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.etat = etat;
}

function separateurproba(positionx, positiony, tempsexec, nbpiece, nbmaxpiece, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.tempsexec = tempsexec;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.etat = etat;
}

function separateursequence(positionx, positiony, tempsexec, nbpiece, nbmaxpiece, sequence, etapesequence, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.tempsexec = tempsexec;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.sequence = sequence;
    //tableau d'une séquence de 0 et de 1
    this.etapesequence = etapesequence;
    this.etat = etat;
}


function feu(positionx, positiony, horloge, tempsrouge, tempsvert, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.horloge = horloge;
    this.tempsrouge = tempsrouge; //temps en seconde passé en rouge
    this.tempsvert = tempsvert; //temps en seconde passé en vert
    this.etat = etat; //0 = rouge et 1 = vert
    //a changer pour changer l'etat initial
}

function empaqueteur(positionx, positiony, nbpiece, nbmaxpiece, couleur, taille, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.couleur = couleur;
    this.taille = taille;
    this.etat = etat;
}

function decoupeur(positionx, positiony, tempsexec, nbpiece, nbpiecesortie, couleur, taille, autorisation, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.tempsexec = tempsexec;
    this.nbpiece = nbpiece;
    this.nbpiecesortie = nbpiecesortie;
    //le nbpiecesortie correspond ici au nombre de piece en sortie
    this.couleur = couleur;
    this.taille = taille;
    this.autorisation = autorisation;
    this.etat = etat;
}

function assembleur(positionx, positiony, nbpiece, nbmaxpiece, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.etat = etat;
}

function desassembleur(positionx, positiony, nbpiece, nbmaxpiece, couleur, taille, qualite, etat) {
    this.positionx = positionx;
    this.positiony = positiony;
    this.nbpiece = nbpiece;
    this.nbmaxpiece = nbmaxpiece;
    this.couleur = couleur;
    this.taille = taille;
    this.qualite = qualite;
    this.etat = etat;
}

var NbPiece = 0;
var NbSpawn = 0;
var NbRoute = 0;
var NbTesteur = 0;
var NbSeparateurP = 0;
var NbSeparateurS = 0;
var NbFeu = 0;
var NbEmpaqueteur = 0;
var NbDecoupeur = 0;
var NbAssembleur = 0;
var NbDesassembleur = 0;

var CLOCK = 10;
var random = 0;
var random2 = 0;
var verifrandom = 0;
var veriftemps = 1;

//VARIABLES A CHANGER
var nbdefaut = 100; //une piece sur nbdefaut a un défaut

//LES PIECES DISPONIBLES
var arrPiece = new Array(1000); //1000 pieces
var arrRoute = new Array(300); //300 routes
var arrSpawn = new Array(15); //15 spawn
var arrTesteur = new Array(10); //10 testeurs
var arrSeparateurP = new Array(10); //10 separateurs probabilistes
var arrSeparateurS = new Array(10); //10 separateurs sequenciels
var arrFeu = new Array(10); //10 feux
var arrEmpaqueteur = new Array(10); //10 empaqueteurs
var arrDecoupeur = new Array(10); //10 decoupeurs
var arrAssembleur = new Array(10); //10 assembleurs
var arrDesassembleur = new Array(10); //10 desassembleurs
